/*****************************************************************************

 string.d:

 String Utility Functions

 Copyright (c) 2009 Yoshinori SUDA.

 This program is free software; you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation; either version 2 of the License, or 
 (at your option) any later version.

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 merchantability or fitness for a particular purpose. 

 See gpl.txt for more details.

 ----------------------------------------------------------------------------

 Public Functions:

 - char[][] csv(char[] from)
 - int csv(char[] from, ref char[][] to)

 ----------------------------------------------------------------------------

 Class Hierarchy:

 - (No Entry)

*****************************************************************************/

module suda.string;

char[][] csv(char[] from)
{
	char[][] to;
	csv(from, to);
	return to;
}

int csv(char[] from, ref char[][] to)
{
	int row = 0;
	
	void push(char[] buf)
	{
		if (row >= to.length)
			to.length = to.length * 2;
		to[row++] = buf;
	}
	
	int p = 0;
	bool quote = false;
	
	if (to.length <= 64)
		to.length = 64;
	
	foreach (p2, c; from) {
		if (quote) {
			if (c == '"')
				quote = false;
		}
		else {
			if (c == '"')
				quote = true;
			else if (c == ',') {
				push(from[p..p2]);
				p = p2 + 1;
			}
		}
	}
	if (from.length > p)
		push(from[p..length]);
	to.length = row;
	return to.length;
}
